"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebhookType = exports.VoiceOpcode = exports.VisibilityType = exports.VideoQualityMode = exports.VerificationLevel = exports.UserFlag = exports.TextInputStyle = exports.SystemChannelFlag = exports.StickerType = exports.StickerFormatType = exports.StatusType = exports.PrivacyLevel = exports.PremiumType = exports.PremiumTier = exports.PermissionFlag = exports.MfaLevel = exports.MessageType = exports.MessageFlag = exports.MessageActivityType = exports.MembershipState = exports.InviteTargetType = exports.InteractionType = exports.InteractionCallbackType = exports.IntegrationExpireBehavior = exports.GuildScheduledEventStatus = exports.GuildScheduledEventPrivacyLevel = exports.GuildScheduledEventEntityType = exports.GuildNsfwLevel = exports.GuildFeature = exports.GatewayOpcode = exports.GatewayIntents = exports.ExplicitContentFilterLevel = exports.EmbedType = exports.DefaultMessageNotificationLevel = exports.createRoutes = exports.ComponentType = exports.ChannelType = exports.ChannelFlag = exports.ButtonStyle = exports.AuditLogEvent = exports.ApplicationFlag = exports.ApplicationCommandType = exports.ApplicationCommandPermissionType = exports.ApplicationCommandOptionType = exports.AllowedMentionType = exports.ActivityType = exports.ActivityFlag = void 0;
exports.ActivityFlag = {
    INSTANCE: 1 << 0,
    JOIN: 1 << 1,
    SPECTATE: 1 << 2,
    JOIN_REQUEST: 1 << 3,
    SYNC: 1 << 4,
    PLAY: 1 << 5,
    PARTY_PRIVACY_FRIENDS: 1 << 6,
    PARTY_PRIVACY_VOICE_CHANNEL: 1 << 7,
    EMBEDDED: 1 << 8,
};
var ActivityType;
(function (ActivityType) {
    ActivityType[ActivityType["GAME"] = 0] = "GAME";
    ActivityType[ActivityType["STREAMING"] = 1] = "STREAMING";
    ActivityType[ActivityType["LISTENING"] = 2] = "LISTENING";
    ActivityType[ActivityType["WATCHING"] = 3] = "WATCHING";
    ActivityType[ActivityType["CUSTOM"] = 4] = "CUSTOM";
    ActivityType[ActivityType["COMPETING"] = 5] = "COMPETING";
})(ActivityType = exports.ActivityType || (exports.ActivityType = {}));
;
var AllowedMentionType;
(function (AllowedMentionType) {
    /** Controls role mentions */
    AllowedMentionType["ROLE_MENTIONS"] = "roles";
    /** Controls user mentions */
    AllowedMentionType["USER_MENTIONS"] = "users";
    /** Controls @everyone and @here mentions */
    AllowedMentionType["EVERYONE_MENTIONS"] = "everyone";
})(AllowedMentionType = exports.AllowedMentionType || (exports.AllowedMentionType = {}));
;
var ApplicationCommandOptionType;
(function (ApplicationCommandOptionType) {
    ApplicationCommandOptionType[ApplicationCommandOptionType["SUB_COMMAND"] = 1] = "SUB_COMMAND";
    ApplicationCommandOptionType[ApplicationCommandOptionType["SUB_COMMAND_GROUP"] = 2] = "SUB_COMMAND_GROUP";
    ApplicationCommandOptionType[ApplicationCommandOptionType["STRING"] = 3] = "STRING";
    ApplicationCommandOptionType[ApplicationCommandOptionType["INTEGER"] = 4] = "INTEGER";
    ApplicationCommandOptionType[ApplicationCommandOptionType["BOOLEAN"] = 5] = "BOOLEAN";
    ApplicationCommandOptionType[ApplicationCommandOptionType["USER"] = 6] = "USER";
    ApplicationCommandOptionType[ApplicationCommandOptionType["CHANNEL"] = 7] = "CHANNEL";
    ApplicationCommandOptionType[ApplicationCommandOptionType["ROLE"] = 8] = "ROLE";
    ApplicationCommandOptionType[ApplicationCommandOptionType["MENTIONABLE"] = 9] = "MENTIONABLE";
    ApplicationCommandOptionType[ApplicationCommandOptionType["NUMBER"] = 10] = "NUMBER";
    ApplicationCommandOptionType[ApplicationCommandOptionType["ATTACHMENT"] = 11] = "ATTACHMENT";
})(ApplicationCommandOptionType = exports.ApplicationCommandOptionType || (exports.ApplicationCommandOptionType = {}));
;
var ApplicationCommandPermissionType;
(function (ApplicationCommandPermissionType) {
    ApplicationCommandPermissionType[ApplicationCommandPermissionType["ROLE"] = 1] = "ROLE";
    ApplicationCommandPermissionType[ApplicationCommandPermissionType["USER"] = 2] = "USER";
    ApplicationCommandPermissionType[ApplicationCommandPermissionType["CHANNEL"] = 3] = "CHANNEL";
})(ApplicationCommandPermissionType = exports.ApplicationCommandPermissionType || (exports.ApplicationCommandPermissionType = {}));
;
var ApplicationCommandType;
(function (ApplicationCommandType) {
    /** Slash commands; a text-based command that shows up when a user types / */
    ApplicationCommandType[ApplicationCommandType["CHAT_INPUT"] = 1] = "CHAT_INPUT";
    /** A UI-based command that shows up when you right click or tap on a user */
    ApplicationCommandType[ApplicationCommandType["USER"] = 2] = "USER";
    /** A UI-based command that shows up when you right click or tap on a message */
    ApplicationCommandType[ApplicationCommandType["MESSAGE"] = 3] = "MESSAGE";
})(ApplicationCommandType = exports.ApplicationCommandType || (exports.ApplicationCommandType = {}));
;
exports.ApplicationFlag = {
    /** Intent required for bots in 100 or more servers to receive presence_update events */
    GATEWAY_PRESENCE: 1 << 12,
    /** Intent required for bots in under 100 servers to receive presence_update events, found in Bot Settings */
    GATEWAY_PRESENCE_LIMITED: 1 << 13,
    /** Intent required for bots in 100 or more servers to receive member-related events like guild_member_add. See list of member-related events under GUILD_MEMBERS */
    GATEWAY_GUILD_MEMBERS: 1 << 14,
    /** Intent required for bots in under 100 servers to receive member-related events like guild_member_add, found in Bot Settings. See list of member-related events under GUILD_MEMBERS */
    GATEWAY_GUILD_MEMBERS_LIMITED: 1 << 15,
    /** Indicates unusual growth of an app that prevents verification */
    VERIFICATION_PENDING_GUILD_LIMIT: 1 << 16,
    /** Indicates if an app is embedded within the Discord client (currently unavailable publicly) */
    EMBEDDED: 1 << 17,
    /** Intent required for bots in 100 or more servers to receive message content */
    GATEWAY_MESSAGE_CONTENT: 1 << 18,
    /** Intent required for bots in under 100 servers to receive message content, found in Bot Settings */
    GATEWAY_MESSAGE_CONTENT_LIMITED: 1 << 19,
};
var AuditLogEvent;
(function (AuditLogEvent) {
    /** Server settings were updated */
    AuditLogEvent[AuditLogEvent["GUILD_UPDATE"] = 1] = "GUILD_UPDATE";
    /** Channel was created */
    AuditLogEvent[AuditLogEvent["CHANNEL_CREATE"] = 10] = "CHANNEL_CREATE";
    /** Channel settings were updated */
    AuditLogEvent[AuditLogEvent["CHANNEL_UPDATE"] = 11] = "CHANNEL_UPDATE";
    /** Channel was deleted */
    AuditLogEvent[AuditLogEvent["CHANNEL_DELETE"] = 12] = "CHANNEL_DELETE";
    /** Permission overwrite was added to a channel */
    AuditLogEvent[AuditLogEvent["CHANNEL_OVERWRITE_CREATE"] = 13] = "CHANNEL_OVERWRITE_CREATE";
    /** Permission overwrite was updated for a channel */
    AuditLogEvent[AuditLogEvent["CHANNEL_OVERWRITE_UPDATE"] = 14] = "CHANNEL_OVERWRITE_UPDATE";
    /** Permission overwrite was deleted from a channel */
    AuditLogEvent[AuditLogEvent["CHANNEL_OVERWRITE_DELETE"] = 15] = "CHANNEL_OVERWRITE_DELETE";
    /** Member was removed from server */
    AuditLogEvent[AuditLogEvent["MEMBER_KICK"] = 20] = "MEMBER_KICK";
    /** Members were pruned from server */
    AuditLogEvent[AuditLogEvent["MEMBER_PRUNE"] = 21] = "MEMBER_PRUNE";
    /** Member was banned from server */
    AuditLogEvent[AuditLogEvent["MEMBER_BAN_ADD"] = 22] = "MEMBER_BAN_ADD";
    /** Server ban was lifted for a member */
    AuditLogEvent[AuditLogEvent["MEMBER_BAN_REMOVE"] = 23] = "MEMBER_BAN_REMOVE";
    /** Member was updated in server */
    AuditLogEvent[AuditLogEvent["MEMBER_UPDATE"] = 24] = "MEMBER_UPDATE";
    /** Member was added or removed from a role */
    AuditLogEvent[AuditLogEvent["MEMBER_ROLE_UPDATE"] = 25] = "MEMBER_ROLE_UPDATE";
    /** Member was moved to a different voice channel */
    AuditLogEvent[AuditLogEvent["MEMBER_MOVE"] = 26] = "MEMBER_MOVE";
    /** Member was disconnected from a voice channel */
    AuditLogEvent[AuditLogEvent["MEMBER_DISCONNECT"] = 27] = "MEMBER_DISCONNECT";
    /** Bot user was added to server */
    AuditLogEvent[AuditLogEvent["BOT_ADD"] = 28] = "BOT_ADD";
    /** Role was created */
    AuditLogEvent[AuditLogEvent["ROLE_CREATE"] = 30] = "ROLE_CREATE";
    /** Role was edited */
    AuditLogEvent[AuditLogEvent["ROLE_UPDATE"] = 31] = "ROLE_UPDATE";
    /** Role was deleted */
    AuditLogEvent[AuditLogEvent["ROLE_DELETE"] = 32] = "ROLE_DELETE";
    /** Server invite was created */
    AuditLogEvent[AuditLogEvent["INVITE_CREATE"] = 40] = "INVITE_CREATE";
    /** Server invite was updated */
    AuditLogEvent[AuditLogEvent["INVITE_UPDATE"] = 41] = "INVITE_UPDATE";
    /** Server invite was deleted */
    AuditLogEvent[AuditLogEvent["INVITE_DELETE"] = 42] = "INVITE_DELETE";
    /** Webhook was created */
    AuditLogEvent[AuditLogEvent["WEBHOOK_CREATE"] = 50] = "WEBHOOK_CREATE";
    /** Webhook properties or channel were updated */
    AuditLogEvent[AuditLogEvent["WEBHOOK_UPDATE"] = 51] = "WEBHOOK_UPDATE";
    /** Webhook was deleted */
    AuditLogEvent[AuditLogEvent["WEBHOOK_DELETE"] = 52] = "WEBHOOK_DELETE";
    /** Emoji was created */
    AuditLogEvent[AuditLogEvent["EMOJI_CREATE"] = 60] = "EMOJI_CREATE";
    /** Emoji name was updated */
    AuditLogEvent[AuditLogEvent["EMOJI_UPDATE"] = 61] = "EMOJI_UPDATE";
    /** Emoji was deleted */
    AuditLogEvent[AuditLogEvent["EMOJI_DELETE"] = 62] = "EMOJI_DELETE";
    /** Single message was deleted */
    AuditLogEvent[AuditLogEvent["MESSAGE_DELETE"] = 72] = "MESSAGE_DELETE";
    /** Multiple messages were deleted */
    AuditLogEvent[AuditLogEvent["MESSAGE_BULK_DELETE"] = 73] = "MESSAGE_BULK_DELETE";
    /** Messaged was pinned to a channel */
    AuditLogEvent[AuditLogEvent["MESSAGE_PIN"] = 74] = "MESSAGE_PIN";
    /** Message was unpinned from a channel */
    AuditLogEvent[AuditLogEvent["MESSAGE_UNPIN"] = 75] = "MESSAGE_UNPIN";
    /** App was added to server */
    AuditLogEvent[AuditLogEvent["INTEGRATION_CREATE"] = 80] = "INTEGRATION_CREATE";
    /** App was updated (as an example, its scopes were updated) */
    AuditLogEvent[AuditLogEvent["INTEGRATION_UPDATE"] = 81] = "INTEGRATION_UPDATE";
    /** App was removed from server */
    AuditLogEvent[AuditLogEvent["INTEGRATION_DELETE"] = 82] = "INTEGRATION_DELETE";
    /** Stage instance was created (stage channel becomes live) */
    AuditLogEvent[AuditLogEvent["STAGE_INSTANCE_CREATE"] = 83] = "STAGE_INSTANCE_CREATE";
    /** Stage instace details were updated */
    AuditLogEvent[AuditLogEvent["STAGE_INSTANCE_UPDATE"] = 84] = "STAGE_INSTANCE_UPDATE";
    /** Stage instance was deleted (stage channel no longer live) */
    AuditLogEvent[AuditLogEvent["STAGE_INSTANCE_DELETE"] = 85] = "STAGE_INSTANCE_DELETE";
    /** Sticker was created */
    AuditLogEvent[AuditLogEvent["STICKER_CREATE"] = 90] = "STICKER_CREATE";
    /** Sticker details were updated */
    AuditLogEvent[AuditLogEvent["STICKER_UPDATE"] = 91] = "STICKER_UPDATE";
    /** Sticker was deleted */
    AuditLogEvent[AuditLogEvent["STICKER_DELETE"] = 92] = "STICKER_DELETE";
    /** Event was created */
    AuditLogEvent[AuditLogEvent["GUILD_SCHEDULED_EVENT_CREATE"] = 100] = "GUILD_SCHEDULED_EVENT_CREATE";
    /** Event was updated */
    AuditLogEvent[AuditLogEvent["GUILD_SCHEDULED_EVENT_UPDATE"] = 101] = "GUILD_SCHEDULED_EVENT_UPDATE";
    /** Event was cancelled */
    AuditLogEvent[AuditLogEvent["GUILD_SCHEDULED_EVENT_DELETE"] = 102] = "GUILD_SCHEDULED_EVENT_DELETE";
    /** Thread was created in a channel */
    AuditLogEvent[AuditLogEvent["THREAD_CREATE"] = 110] = "THREAD_CREATE";
    /** Thread was updated */
    AuditLogEvent[AuditLogEvent["THREAD_UPDATE"] = 111] = "THREAD_UPDATE";
    /** Thread was deleted */
    AuditLogEvent[AuditLogEvent["THREAD_DELETE"] = 112] = "THREAD_DELETE";
    /** Permissions were updated for a command */
    AuditLogEvent[AuditLogEvent["APPLICATION_COMMAND_PERMISSION_UPDATE"] = 121] = "APPLICATION_COMMAND_PERMISSION_UPDATE";
})(AuditLogEvent = exports.AuditLogEvent || (exports.AuditLogEvent = {}));
;
var ButtonStyle;
(function (ButtonStyle) {
    ButtonStyle[ButtonStyle["PRIMARY"] = 1] = "PRIMARY";
    ButtonStyle[ButtonStyle["SECONDARY"] = 2] = "SECONDARY";
    ButtonStyle[ButtonStyle["SUCCESS"] = 3] = "SUCCESS";
    ButtonStyle[ButtonStyle["DANGER"] = 4] = "DANGER";
    ButtonStyle[ButtonStyle["LINK"] = 5] = "LINK";
})(ButtonStyle = exports.ButtonStyle || (exports.ButtonStyle = {}));
;
exports.ChannelFlag = {
    /** this thread is pinned to the top of its parent forum channel */
    PINNED: 1 << 1,
};
var ChannelType;
(function (ChannelType) {
    /** a text channel within a server */
    ChannelType[ChannelType["GUILD_TEXT"] = 0] = "GUILD_TEXT";
    /** a direct message between users */
    ChannelType[ChannelType["DM"] = 1] = "DM";
    /** a voice channel within a server */
    ChannelType[ChannelType["GUILD_VOICE"] = 2] = "GUILD_VOICE";
    /** a direct message between multiple users */
    ChannelType[ChannelType["GROUP_DM"] = 3] = "GROUP_DM";
    /** an organizational category that contains up to 50 channels */
    ChannelType[ChannelType["GUILD_CATEGORY"] = 4] = "GUILD_CATEGORY";
    /** a channel that users can follow and crosspost into their own server */
    ChannelType[ChannelType["GUILD_NEWS"] = 5] = "GUILD_NEWS";
    /** a temporary sub-channel within a GUILD_NEWS channel */
    ChannelType[ChannelType["GUILD_NEWS_THREAD"] = 10] = "GUILD_NEWS_THREAD";
    /** a temporary sub-channel within a GUILD_TEXT channel */
    ChannelType[ChannelType["GUILD_PUBLIC_THREAD"] = 11] = "GUILD_PUBLIC_THREAD";
    /** a temporary sub-channel within a GUILD_TEXT channel that is only viewable by those invited and those with the MANAGE_THREADS permission */
    ChannelType[ChannelType["GUILD_PRIVATE_THREAD"] = 12] = "GUILD_PRIVATE_THREAD";
    /** a voice channel for hosting events with an audience */
    ChannelType[ChannelType["GUILD_STAGE_VOICE"] = 13] = "GUILD_STAGE_VOICE";
    /** the channel in a hub containing the listed servers */
    ChannelType[ChannelType["GUILD_DIRECTORY"] = 14] = "GUILD_DIRECTORY";
    /** (still in development) a channel that can only contain threads */
    ChannelType[ChannelType["GUILD_FORUM"] = 15] = "GUILD_FORUM";
})(ChannelType = exports.ChannelType || (exports.ChannelType = {}));
;
var ComponentType;
(function (ComponentType) {
    /** A container for other components */
    ComponentType[ComponentType["ACTION_ROW"] = 1] = "ACTION_ROW";
    /** A button object */
    ComponentType[ComponentType["BUTTON"] = 2] = "BUTTON";
    /** A select menu for picking from choices */
    ComponentType[ComponentType["SELECT_MENU"] = 3] = "SELECT_MENU";
    /** A text input object */
    ComponentType[ComponentType["TEXT_INPUT"] = 4] = "TEXT_INPUT";
})(ComponentType = exports.ComponentType || (exports.ComponentType = {}));
;
function createRoutes(fetch) {
    return {
        addGuildMember: (guildId, userId, params, options) => fetch({
            method: "PUT",
            url: `/guilds/${guildId}/members/${userId}`,
            params,
            options,
        }),
        addGuildMemberRole: (guildId, userId, roleId, options) => fetch({
            method: "PUT",
            url: `/guilds/${guildId}/members/${userId}/roles/${roleId}`,
            options,
        }),
        addThreadMember: (channelId, userId, options) => fetch({
            method: "PUT",
            url: `/channels/${channelId}/thread-members/${userId}`,
            options,
        }),
        batchEditApplicationCommandPermissions: (applicationId, guildId, options) => fetch({
            method: "PUT",
            url: `/applications/${applicationId}/guilds/${guildId}/commands/permissions`,
            options,
        }),
        beginGuildPrune: (guildId, params, options) => fetch({
            method: "POST",
            url: `/guilds/${guildId}/prune`,
            params,
            options,
        }),
        bulkDeleteMessages: (channelId, params, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/messages/bulk-delete`,
            params,
            options,
        }),
        bulkOverwriteGlobalApplicationCommands: (applicationId, options) => fetch({
            method: "PUT",
            url: `/applications/${applicationId}/commands`,
            options,
        }),
        bulkOverwriteGuildApplicationCommands: (applicationId, guildId, params, options) => fetch({
            method: "PUT",
            url: `/applications/${applicationId}/guilds/${guildId}/commands`,
            params,
            options,
        }),
        createChannelInvite: (channelId, params, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/invites`,
            params,
            options,
        }),
        createDm: (params, options) => fetch({
            method: "POST",
            url: `/users/@me/channels`,
            params,
            options,
        }),
        createFollowupMessage: (applicationId, interactionToken, options) => fetch({
            method: "POST",
            url: `/webhooks/${applicationId}/${interactionToken}`,
            options,
        }),
        createGlobalApplicationCommand: (applicationId, params, options) => fetch({
            method: "POST",
            url: `/applications/${applicationId}/commands`,
            params,
            options,
        }),
        createGroupDm: (params, options) => fetch({
            method: "POST",
            url: `/users/@me/channels`,
            params,
            options,
        }),
        createGuild: (params, options) => fetch({
            method: "POST",
            url: `/guilds`,
            params,
            options,
        }),
        createGuildApplicationCommand: (applicationId, guildId, params, options) => fetch({
            method: "POST",
            url: `/applications/${applicationId}/guilds/${guildId}/commands`,
            params,
            options,
        }),
        createGuildBan: (guildId, userId, params, options) => fetch({
            method: "PUT",
            url: `/guilds/${guildId}/bans/${userId}`,
            params,
            options,
        }),
        createGuildChannel: (guildId, params, options) => fetch({
            method: "POST",
            url: `/guilds/${guildId}/channels`,
            params,
            options,
        }),
        createGuildEmoji: (guildId, params, options) => fetch({
            method: "POST",
            url: `/guilds/${guildId}/emojis`,
            params,
            options,
        }),
        createGuildFromGuildTemplate: (templateCode, params, options) => fetch({
            method: "POST",
            url: `/guilds/templates/${templateCode}`,
            params,
            options,
        }),
        createGuildRole: (guildId, params, options) => fetch({
            method: "POST",
            url: `/guilds/${guildId}/roles`,
            params,
            options,
        }),
        createGuildScheduledEvent: (guildId, params, options) => fetch({
            method: "POST",
            url: `/guilds/${guildId}/scheduled-events`,
            params,
            options,
        }),
        createGuildSticker: (guildId, params, options) => fetch({
            method: "POST",
            url: `/guilds/${guildId}/stickers`,
            params,
            options,
        }),
        createGuildTemplate: (guildId, params, options) => fetch({
            method: "POST",
            url: `/guilds/${guildId}/templates`,
            params,
            options,
        }),
        createInteractionResponse: (interactionId, interactionToken, params, options) => fetch({
            method: "POST",
            url: `/interactions/${interactionId}/${interactionToken}/callback`,
            params,
            options,
        }),
        createMessage: (channelId, params, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/messages`,
            params,
            options,
        }),
        createReaction: (channelId, messageId, emoji, options) => fetch({
            method: "PUT",
            url: `/channels/${channelId}/messages/${messageId}/reactions/${emoji}/@me`,
            options,
        }),
        createStageInstance: (params, options) => fetch({
            method: "POST",
            url: `/stage-instances`,
            params,
            options,
        }),
        createWebhook: (channelId, params, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/webhooks`,
            params,
            options,
        }),
        crosspostMessage: (channelId, messageId, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/messages/${messageId}/crosspost`,
            options,
        }),
        deleteAllReactions: (channelId, messageId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/messages/${messageId}/reactions`,
            options,
        }),
        deleteAllReactionsForEmoji: (channelId, messageId, emoji, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/messages/${messageId}/reactions/${emoji}`,
            options,
        }),
        deleteChannelPermission: (channelId, overwriteId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/permissions/${overwriteId}`,
            options,
        }),
        deletecloseChannel: (channelId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}`,
            options,
        }),
        deleteFollowupMessage: (applicationId, interactionToken, messageId, options) => fetch({
            method: "DELETE",
            url: `/webhooks/${applicationId}/${interactionToken}/messages/${messageId}`,
            options,
        }),
        deleteGlobalApplicationCommand: (applicationId, commandId, options) => fetch({
            method: "DELETE",
            url: `/applications/${applicationId}/commands/${commandId}`,
            options,
        }),
        deleteGuild: (guildId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}`,
            options,
        }),
        deleteGuildApplicationCommand: (applicationId, guildId, commandId, options) => fetch({
            method: "DELETE",
            url: `/applications/${applicationId}/guilds/${guildId}/commands/${commandId}`,
            options,
        }),
        deleteGuildEmoji: (guildId, emojiId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/emojis/${emojiId}`,
            options,
        }),
        deleteGuildIntegration: (guildId, integrationId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/integrations/${integrationId}`,
            options,
        }),
        deleteGuildRole: (guildId, roleId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/roles/${roleId}`,
            options,
        }),
        deleteGuildScheduledEvent: (guildId, guildScheduledEventId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/scheduled-events/${guildScheduledEventId}`,
            options,
        }),
        deleteGuildSticker: (guildId, stickerId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/stickers/${stickerId}`,
            options,
        }),
        deleteGuildTemplate: (guildId, templateCode, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/templates/${templateCode}`,
            options,
        }),
        deleteInvite: (inviteCode, options) => fetch({
            method: "DELETE",
            url: `/invites/${inviteCode}`,
            options,
        }),
        deleteMessage: (channelId, messageId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/messages/${messageId}`,
            options,
        }),
        deleteOriginalInteractionResponse: (applicationId, interactionToken, options) => fetch({
            method: "DELETE",
            url: `/webhooks/${applicationId}/${interactionToken}/messages/@original`,
            options,
        }),
        deleteOwnReaction: (channelId, messageId, emoji, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/messages/${messageId}/reactions/${emoji}/@me`,
            options,
        }),
        deleteStageInstance: (channelId, options) => fetch({
            method: "DELETE",
            url: `/stage-instances/${channelId}`,
            options,
        }),
        deleteUserReaction: (channelId, messageId, emoji, userId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/messages/${messageId}/reactions/${emoji}/${userId}`,
            options,
        }),
        deleteWebhook: (webhookId, options) => fetch({
            method: "DELETE",
            url: `/webhooks/${webhookId}`,
            options,
        }),
        deleteWebhookMessage: (webhookId, webhookToken, messageId, params, options) => fetch({
            method: "DELETE",
            url: `/webhooks/${webhookId}/${webhookToken}/messages/${messageId}`,
            params,
            options,
        }),
        deleteWebhookWithToken: (webhookId, webhookToken, options) => fetch({
            method: "DELETE",
            url: `/webhooks/${webhookId}/${webhookToken}`,
            options,
        }),
        editApplicationCommandPermissions: (applicationId, guildId, commandId, params, options) => fetch({
            method: "PUT",
            url: `/applications/${applicationId}/guilds/${guildId}/commands/${commandId}/permissions`,
            params,
            options,
        }),
        editChannelPermissions: (channelId, overwriteId, params, options) => fetch({
            method: "PUT",
            url: `/channels/${channelId}/permissions/${overwriteId}`,
            params,
            options,
        }),
        editFollowupMessage: (applicationId, interactionToken, messageId, options) => fetch({
            method: "PATCH",
            url: `/webhooks/${applicationId}/${interactionToken}/messages/${messageId}`,
            options,
        }),
        editGlobalApplicationCommand: (applicationId, commandId, params, options) => fetch({
            method: "PATCH",
            url: `/applications/${applicationId}/commands/${commandId}`,
            params,
            options,
        }),
        editGuildApplicationCommand: (applicationId, guildId, commandId, params, options) => fetch({
            method: "PATCH",
            url: `/applications/${applicationId}/guilds/${guildId}/commands/${commandId}`,
            params,
            options,
        }),
        editMessage: (channelId, messageId, params, options) => fetch({
            method: "PATCH",
            url: `/channels/${channelId}/messages/${messageId}`,
            params,
            options,
        }),
        editOriginalInteractionResponse: (applicationId, interactionToken, options) => fetch({
            method: "PATCH",
            url: `/webhooks/${applicationId}/${interactionToken}/messages/@original`,
            options,
        }),
        editWebhookMessage: (webhookId, webhookToken, messageId, params, options) => fetch({
            method: "PATCH",
            url: `/webhooks/${webhookId}/${webhookToken}/messages/${messageId}`,
            params,
            options,
        }),
        executeGitHubCompatibleWebhook: (webhookId, webhookToken, options) => fetch({
            method: "POST",
            url: `/webhooks/${webhookId}/${webhookToken}/github`,
            options,
        }),
        executeSlackCompatibleWebhook: (webhookId, webhookToken, options) => fetch({
            method: "POST",
            url: `/webhooks/${webhookId}/${webhookToken}/slack`,
            options,
        }),
        executeWebhook: (webhookId, webhookToken, params, options) => fetch({
            method: "POST",
            url: `/webhooks/${webhookId}/${webhookToken}`,
            params,
            options,
        }),
        followNewsChannel: (channelId, params, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/followers`,
            params,
            options,
        }),
        getApplicationCommandPermissions: (applicationId, guildId, commandId, options) => fetch({
            method: "GET",
            url: `/applications/${applicationId}/guilds/${guildId}/commands/${commandId}/permissions`,
            options,
        }),
        getChannel: (channelId, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}`,
            options,
        }),
        getChannelInvites: (channelId, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/invites`,
            options,
        }),
        getChannelMessage: (channelId, messageId, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/messages/${messageId}`,
            options,
        }),
        getChannelMessages: (channelId, params, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/messages`,
            params,
            options,
        }),
        getChannelWebhooks: (channelId, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/webhooks`,
            options,
        }),
        getCurrentUser: (options) => fetch({
            method: "GET",
            url: `/users/@me`,
            options,
        }),
        getCurrentUserGuildMember: (guildId, options) => fetch({
            method: "GET",
            url: `/users/@me/guilds/${guildId}/member`,
            options,
        }),
        getCurrentUserGuilds: (params, options) => fetch({
            method: "GET",
            url: `/users/@me/guilds`,
            params,
            options,
        }),
        getFollowupMessage: (applicationId, interactionToken, messageId, options) => fetch({
            method: "GET",
            url: `/webhooks/${applicationId}/${interactionToken}/messages/${messageId}`,
            options,
        }),
        getGateway: (options) => fetch({
            method: "GET",
            url: `/gateway`,
            options,
        }),
        getGatewayBot: (options) => fetch({
            method: "GET",
            url: `/gateway/bot`,
            options,
        }),
        getGlobalApplicationCommand: (applicationId, commandId, options) => fetch({
            method: "GET",
            url: `/applications/${applicationId}/commands/${commandId}`,
            options,
        }),
        getGlobalApplicationCommands: (applicationId, params, options) => fetch({
            method: "GET",
            url: `/applications/${applicationId}/commands`,
            params,
            options,
        }),
        getGuild: (guildId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}`,
            params,
            options,
        }),
        getGuildApplicationCommand: (applicationId, guildId, commandId, options) => fetch({
            method: "GET",
            url: `/applications/${applicationId}/guilds/${guildId}/commands/${commandId}`,
            options,
        }),
        getGuildApplicationCommandPermissions: (applicationId, guildId, options) => fetch({
            method: "GET",
            url: `/applications/${applicationId}/guilds/${guildId}/commands/permissions`,
            options,
        }),
        getGuildApplicationCommands: (applicationId, guildId, params, options) => fetch({
            method: "GET",
            url: `/applications/${applicationId}/guilds/${guildId}/commands`,
            params,
            options,
        }),
        getGuildAuditLog: (guildId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/audit-logs`,
            params,
            options,
        }),
        getGuildBan: (guildId, userId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/bans/${userId}`,
            options,
        }),
        getGuildBans: (guildId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/bans`,
            params,
            options,
        }),
        getGuildChannels: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/channels`,
            options,
        }),
        getGuildEmoji: (guildId, emojiId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/emojis/${emojiId}`,
            options,
        }),
        getGuildIntegrations: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/integrations`,
            options,
        }),
        getGuildInvites: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/invites`,
            options,
        }),
        getGuildMember: (guildId, userId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/members/${userId}`,
            options,
        }),
        getGuildPreview: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/preview`,
            options,
        }),
        getGuildPruneCount: (guildId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/prune`,
            params,
            options,
        }),
        getGuildRoles: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/roles`,
            options,
        }),
        getGuildScheduledEvent: (guildId, guildScheduledEventId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/scheduled-events/${guildScheduledEventId}`,
            params,
            options,
        }),
        getGuildScheduledEventUsers: (guildId, guildScheduledEventId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/scheduled-events/${guildScheduledEventId}/users`,
            params,
            options,
        }),
        getGuildSticker: (guildId, stickerId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/stickers/${stickerId}`,
            options,
        }),
        getGuildTemplate: (templateCode, options) => fetch({
            method: "GET",
            url: `/guilds/templates/${templateCode}`,
            options,
        }),
        getGuildTemplates: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/templates`,
            options,
        }),
        getGuildVanityUrl: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/vanity-url`,
            options,
        }),
        getGuildVoiceRegions: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/regions`,
            options,
        }),
        getGuildWebhooks: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/webhooks`,
            options,
        }),
        getGuildWelcomeScreen: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/welcome-screen`,
            options,
        }),
        getGuildWidget: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/widget.json`,
            options,
        }),
        getGuildWidgetImage: (guildId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/widget.png`,
            params,
            options,
        }),
        getGuildWidgetSettings: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/widget`,
            options,
        }),
        getInvite: (inviteCode, params, options) => fetch({
            method: "GET",
            url: `/invites/${inviteCode}`,
            params,
            options,
        }),
        getOriginalInteractionResponse: (applicationId, interactionToken, options) => fetch({
            method: "GET",
            url: `/webhooks/${applicationId}/${interactionToken}/messages/@original`,
            options,
        }),
        getPinnedMessages: (channelId, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/pins`,
            options,
        }),
        getReactions: (channelId, messageId, emoji, params, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/messages/${messageId}/reactions/${emoji}`,
            params,
            options,
        }),
        getStageInstance: (channelId, options) => fetch({
            method: "GET",
            url: `/stage-instances/${channelId}`,
            options,
        }),
        getSticker: (stickerId, options) => fetch({
            method: "GET",
            url: `/stickers/${stickerId}`,
            options,
        }),
        getThreadMember: (channelId, userId, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/thread-members/${userId}`,
            options,
        }),
        getUser: (userId, options) => fetch({
            method: "GET",
            url: `/users/${userId}`,
            options,
        }),
        getUserConnections: (options) => fetch({
            method: "GET",
            url: `/users/@me/connections`,
            options,
        }),
        getWebhook: (webhookId, options) => fetch({
            method: "GET",
            url: `/webhooks/${webhookId}`,
            options,
        }),
        getWebhookMessage: (webhookId, webhookToken, messageId, params, options) => fetch({
            method: "GET",
            url: `/webhooks/${webhookId}/${webhookToken}/messages/${messageId}`,
            params,
            options,
        }),
        getWebhookWithToken: (webhookId, webhookToken, options) => fetch({
            method: "GET",
            url: `/webhooks/${webhookId}/${webhookToken}`,
            options,
        }),
        groupDmAddRecipient: (channelId, userId, params, options) => fetch({
            method: "PUT",
            url: `/channels/${channelId}/recipients/${userId}`,
            params,
            options,
        }),
        groupDmRemoveRecipient: (channelId, userId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/recipients/${userId}`,
            options,
        }),
        joinThread: (channelId, options) => fetch({
            method: "PUT",
            url: `/channels/${channelId}/thread-members/@me`,
            options,
        }),
        leaveGuild: (guildId, options) => fetch({
            method: "DELETE",
            url: `/users/@me/guilds/${guildId}`,
            options,
        }),
        leaveThread: (channelId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/thread-members/@me`,
            options,
        }),
        listActiveGuildThreads: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/threads/active`,
            options,
        }),
        listGuildEmojis: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/emojis`,
            options,
        }),
        listGuildMembers: (guildId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/members`,
            params,
            options,
        }),
        listGuildStickers: (guildId, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/stickers`,
            options,
        }),
        listJoinedPrivateArchivedThreads: (channelId, params, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/users/@me/threads/archived/private`,
            params,
            options,
        }),
        listNitroStickerPacks: (options) => fetch({
            method: "GET",
            url: `/sticker-packs`,
            options,
        }),
        listPrivateArchivedThreads: (channelId, params, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/threads/archived/private`,
            params,
            options,
        }),
        listPublicArchivedThreads: (channelId, params, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/threads/archived/public`,
            params,
            options,
        }),
        listScheduledEventsForGuild: (guildId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/scheduled-events`,
            params,
            options,
        }),
        listThreadMembers: (channelId, options) => fetch({
            method: "GET",
            url: `/channels/${channelId}/thread-members`,
            options,
        }),
        listVoiceRegions: (options) => fetch({
            method: "GET",
            url: `/voice/regions`,
            options,
        }),
        modifyChannel: (channelId, params, options) => fetch({
            method: "PATCH",
            url: `/channels/${channelId}`,
            params,
            options,
        }),
        modifyCurrentMember: (guildId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/members/@me`,
            params,
            options,
        }),
        modifyCurrentUser: (params, options) => fetch({
            method: "PATCH",
            url: `/users/@me`,
            params,
            options,
        }),
        modifyCurrentUserNick: (guildId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/members/@me/nick`,
            params,
            options,
        }),
        modifyCurrentUserVoiceState: (guildId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/voice-states/@me`,
            params,
            options,
        }),
        modifyGuild: (guildId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}`,
            params,
            options,
        }),
        modifyGuildChannelPositions: (guildId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/channels`,
            params,
            options,
        }),
        modifyGuildEmoji: (guildId, emojiId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/emojis/${emojiId}`,
            params,
            options,
        }),
        modifyGuildMember: (guildId, userId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/members/${userId}`,
            params,
            options,
        }),
        modifyGuildRole: (guildId, roleId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/roles/${roleId}`,
            params,
            options,
        }),
        modifyGuildRolePositions: (guildId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/roles`,
            params,
            options,
        }),
        modifyGuildScheduledEvent: (guildId, guildScheduledEventId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/scheduled-events/${guildScheduledEventId}`,
            params,
            options,
        }),
        modifyGuildSticker: (guildId, stickerId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/stickers/${stickerId}`,
            params,
            options,
        }),
        modifyGuildTemplate: (guildId, templateCode, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/templates/${templateCode}`,
            params,
            options,
        }),
        modifyGuildWelcomeScreen: (guildId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/welcome-screen`,
            params,
            options,
        }),
        modifyGuildWidget: (guildId, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/widget`,
            options,
        }),
        modifyStageInstance: (channelId, params, options) => fetch({
            method: "PATCH",
            url: `/stage-instances/${channelId}`,
            params,
            options,
        }),
        modifyUserVoiceState: (guildId, userId, params, options) => fetch({
            method: "PATCH",
            url: `/guilds/${guildId}/voice-states/${userId}`,
            params,
            options,
        }),
        modifyWebhook: (webhookId, params, options) => fetch({
            method: "PATCH",
            url: `/webhooks/${webhookId}`,
            params,
            options,
        }),
        modifyWebhookWithToken: (webhookId, webhookToken, options) => fetch({
            method: "PATCH",
            url: `/webhooks/${webhookId}/${webhookToken}`,
            options,
        }),
        pinMessage: (channelId, messageId, options) => fetch({
            method: "PUT",
            url: `/channels/${channelId}/pins/${messageId}`,
            options,
        }),
        removeGuildBan: (guildId, userId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/bans/${userId}`,
            options,
        }),
        removeGuildMember: (guildId, userId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/members/${userId}`,
            options,
        }),
        removeGuildMemberRole: (guildId, userId, roleId, options) => fetch({
            method: "DELETE",
            url: `/guilds/${guildId}/members/${userId}/roles/${roleId}`,
            options,
        }),
        removeThreadMember: (channelId, userId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/thread-members/${userId}`,
            options,
        }),
        searchGuildMembers: (guildId, params, options) => fetch({
            method: "GET",
            url: `/guilds/${guildId}/members/search`,
            params,
            options,
        }),
        startThreadFromMessage: (channelId, messageId, params, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/messages/${messageId}/threads`,
            params,
            options,
        }),
        startThreadInForumChannel: (channelId, params, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/threads`,
            params,
            options,
        }),
        startThreadWithoutMessage: (channelId, params, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/threads`,
            params,
            options,
        }),
        syncGuildTemplate: (guildId, templateCode, options) => fetch({
            method: "PUT",
            url: `/guilds/${guildId}/templates/${templateCode}`,
            options,
        }),
        triggerTypingIndicator: (channelId, options) => fetch({
            method: "POST",
            url: `/channels/${channelId}/typing`,
            options,
        }),
        unpinMessage: (channelId, messageId, options) => fetch({
            method: "DELETE",
            url: `/channels/${channelId}/pins/${messageId}`,
            options,
        }),
    };
}
exports.createRoutes = createRoutes;
var DefaultMessageNotificationLevel;
(function (DefaultMessageNotificationLevel) {
    /** members will receive notifications for all messages by default */
    DefaultMessageNotificationLevel[DefaultMessageNotificationLevel["ALL_MESSAGES"] = 0] = "ALL_MESSAGES";
    /** members will receive notifications only for messages that @mention them by default */
    DefaultMessageNotificationLevel[DefaultMessageNotificationLevel["ONLY_MENTIONS"] = 1] = "ONLY_MENTIONS";
})(DefaultMessageNotificationLevel = exports.DefaultMessageNotificationLevel || (exports.DefaultMessageNotificationLevel = {}));
;
var EmbedType;
(function (EmbedType) {
    /** generic embed rendered from embed attributes */
    EmbedType["RICH"] = "rich";
    /** image embed */
    EmbedType["IMAGE"] = "image";
    /** video embed */
    EmbedType["VIDEO"] = "video";
    /** animated gif image embed rendered as a video embed */
    EmbedType["GIFV"] = "gifv";
    /** article embed */
    EmbedType["ARTICLE"] = "article";
    /** link embed */
    EmbedType["LINK"] = "link";
})(EmbedType = exports.EmbedType || (exports.EmbedType = {}));
;
var ExplicitContentFilterLevel;
(function (ExplicitContentFilterLevel) {
    /** media content will not be scanned */
    ExplicitContentFilterLevel[ExplicitContentFilterLevel["DISABLED"] = 0] = "DISABLED";
    /** media content sent by members without roles will be scanned */
    ExplicitContentFilterLevel[ExplicitContentFilterLevel["MEMBERS_WITHOUT_ROLES"] = 1] = "MEMBERS_WITHOUT_ROLES";
    /** media content sent by all members will be scanned */
    ExplicitContentFilterLevel[ExplicitContentFilterLevel["ALL_MEMBERS"] = 2] = "ALL_MEMBERS";
})(ExplicitContentFilterLevel = exports.ExplicitContentFilterLevel || (exports.ExplicitContentFilterLevel = {}));
;
exports.GatewayIntents = {
    GUILDS: 1 << 0,
    GUILD_MEMBERS: 1 << 1,
    GUILD_BANS: 1 << 2,
    GUILD_EMOJIS_AND_STICKERS: 1 << 3,
    GUILD_INTEGRATIONS: 1 << 4,
    GUILD_WEBHOOKS: 1 << 5,
    GUILD_INVITES: 1 << 6,
    GUILD_VOICE_STATES: 1 << 7,
    GUILD_PRESENCES: 1 << 8,
    GUILD_MESSAGES: 1 << 9,
    GUILD_MESSAGE_REACTIONS: 1 << 10,
    GUILD_MESSAGE_TYPING: 1 << 11,
    DIRECT_MESSAGES: 1 << 12,
    DIRECT_MESSAGE_REACTIONS: 1 << 13,
    DIRECT_MESSAGE_TYPING: 1 << 14,
    MESSAGE_CONTENT: 1 << 15,
    GUILD_SCHEDULED_EVENTS: 1 << 16,
};
var GatewayOpcode;
(function (GatewayOpcode) {
    /** An event was dispatched. */
    GatewayOpcode[GatewayOpcode["DISPATCH"] = 0] = "DISPATCH";
    /** Fired periodically by the client to keep the connection alive. */
    GatewayOpcode[GatewayOpcode["HEARTBEAT"] = 1] = "HEARTBEAT";
    /** Starts a new session during the initial handshake. */
    GatewayOpcode[GatewayOpcode["IDENTIFY"] = 2] = "IDENTIFY";
    /** Update the client's presence. */
    GatewayOpcode[GatewayOpcode["PRESENCE_UPDATE"] = 3] = "PRESENCE_UPDATE";
    /** Used to join/leave or move between voice channels. */
    GatewayOpcode[GatewayOpcode["VOICE_STATE_UPDATE"] = 4] = "VOICE_STATE_UPDATE";
    /** Resume a previous session that was disconnected. */
    GatewayOpcode[GatewayOpcode["RESUME"] = 6] = "RESUME";
    /** You should attempt to reconnect and resume immediately. */
    GatewayOpcode[GatewayOpcode["RECONNECT"] = 7] = "RECONNECT";
    /** Request information about offline guild members in a large guild. */
    GatewayOpcode[GatewayOpcode["REQUEST_GUILD_MEMBERS"] = 8] = "REQUEST_GUILD_MEMBERS";
    /** The session has been invalidated. You should reconnect and identify/resume accordingly. */
    GatewayOpcode[GatewayOpcode["INVALID_SESSION"] = 9] = "INVALID_SESSION";
    /** Sent immediately after connecting, contains the heartbeat_interval to use. */
    GatewayOpcode[GatewayOpcode["HELLO"] = 10] = "HELLO";
    /** Sent in response to receiving a heartbeat to acknowledge that it has been received. */
    GatewayOpcode[GatewayOpcode["HEARTBEAT_ACK"] = 11] = "HEARTBEAT_ACK";
})(GatewayOpcode = exports.GatewayOpcode || (exports.GatewayOpcode = {}));
;
var GuildFeature;
(function (GuildFeature) {
    /** guild has access to set an animated guild banner image */
    GuildFeature["ANIMATED_BANNER"] = "ANIMATED_BANNER";
    /** guild has access to set an animated guild icon */
    GuildFeature["ANIMATED_ICON"] = "ANIMATED_ICON";
    /** guild has access to set a guild banner image */
    GuildFeature["BANNER"] = "BANNER";
    /** guild has access to use commerce features (i.e. create store channels) */
    GuildFeature["COMMERCE"] = "COMMERCE";
    /** guild can enable welcome screen, Membership Screening, stage channels and discovery, and receives community updates */
    GuildFeature["COMMUNITY"] = "COMMUNITY";
    /** guild is able to be discovered in the directory */
    GuildFeature["DISCOVERABLE"] = "DISCOVERABLE";
    /** guild is able to be featured in the directory */
    GuildFeature["FEATURABLE"] = "FEATURABLE";
    /** guild has access to set an invite splash background */
    GuildFeature["INVITE_SPLASH"] = "INVITE_SPLASH";
    /** guild has enabled Membership Screening */
    GuildFeature["MEMBER_VERIFICATION_GATE_ENABLED"] = "MEMBER_VERIFICATION_GATE_ENABLED";
    /** guild has enabled monetization */
    GuildFeature["MONETIZATION_ENABLED"] = "MONETIZATION_ENABLED";
    /** guild has increased custom sticker slots */
    GuildFeature["MORE_STICKERS"] = "MORE_STICKERS";
    /** guild has access to create news channels */
    GuildFeature["NEWS"] = "NEWS";
    /** guild is partnered */
    GuildFeature["PARTNERED"] = "PARTNERED";
    /** guild can be previewed before joining via Membership Screening or the directory */
    GuildFeature["PREVIEW_ENABLED"] = "PREVIEW_ENABLED";
    /** guild has access to create private threads */
    GuildFeature["PRIVATE_THREADS"] = "PRIVATE_THREADS";
    /** guild is able to set role icons */
    GuildFeature["ROLE_ICONS"] = "ROLE_ICONS";
    /** guild has enabled ticketed events */
    GuildFeature["TICKETED_EVENTS_ENABLED"] = "TICKETED_EVENTS_ENABLED";
    /** guild has access to set a vanity URL */
    GuildFeature["VANITY_URL"] = "VANITY_URL";
    /** guild is verified */
    GuildFeature["VERIFIED"] = "VERIFIED";
    /** guild has access to set 384kbps bitrate in voice (previously VIP voice servers) */
    GuildFeature["VIP_REGIONS"] = "VIP_REGIONS";
    /** guild has enabled the welcome screen */
    GuildFeature["WELCOME_SCREEN_ENABLED"] = "WELCOME_SCREEN_ENABLED";
})(GuildFeature = exports.GuildFeature || (exports.GuildFeature = {}));
;
var GuildNsfwLevel;
(function (GuildNsfwLevel) {
    GuildNsfwLevel[GuildNsfwLevel["DEFAULT"] = 0] = "DEFAULT";
    GuildNsfwLevel[GuildNsfwLevel["EXPLICIT"] = 1] = "EXPLICIT";
    GuildNsfwLevel[GuildNsfwLevel["SAFE"] = 2] = "SAFE";
    GuildNsfwLevel[GuildNsfwLevel["AGE_RESTRICTED"] = 3] = "AGE_RESTRICTED";
})(GuildNsfwLevel = exports.GuildNsfwLevel || (exports.GuildNsfwLevel = {}));
;
var GuildScheduledEventEntityType;
(function (GuildScheduledEventEntityType) {
    GuildScheduledEventEntityType[GuildScheduledEventEntityType["STAGE_INSTANCE"] = 1] = "STAGE_INSTANCE";
    GuildScheduledEventEntityType[GuildScheduledEventEntityType["VOICE"] = 2] = "VOICE";
    GuildScheduledEventEntityType[GuildScheduledEventEntityType["EXTERNAL"] = 3] = "EXTERNAL";
})(GuildScheduledEventEntityType = exports.GuildScheduledEventEntityType || (exports.GuildScheduledEventEntityType = {}));
;
var GuildScheduledEventPrivacyLevel;
(function (GuildScheduledEventPrivacyLevel) {
    /** the scheduled event is only accessible to guild members */
    GuildScheduledEventPrivacyLevel[GuildScheduledEventPrivacyLevel["GUILD_ONLY"] = 2] = "GUILD_ONLY";
})(GuildScheduledEventPrivacyLevel = exports.GuildScheduledEventPrivacyLevel || (exports.GuildScheduledEventPrivacyLevel = {}));
;
var GuildScheduledEventStatus;
(function (GuildScheduledEventStatus) {
    GuildScheduledEventStatus[GuildScheduledEventStatus["SCHEDULED"] = 1] = "SCHEDULED";
    GuildScheduledEventStatus[GuildScheduledEventStatus["ACTIVE"] = 2] = "ACTIVE";
    GuildScheduledEventStatus[GuildScheduledEventStatus["COMPLETED"] = 3] = "COMPLETED";
    GuildScheduledEventStatus[GuildScheduledEventStatus["CANCELED"] = 4] = "CANCELED";
})(GuildScheduledEventStatus = exports.GuildScheduledEventStatus || (exports.GuildScheduledEventStatus = {}));
;
var IntegrationExpireBehavior;
(function (IntegrationExpireBehavior) {
    IntegrationExpireBehavior[IntegrationExpireBehavior["REMOVE_ROLE"] = 0] = "REMOVE_ROLE";
    IntegrationExpireBehavior[IntegrationExpireBehavior["KICK"] = 1] = "KICK";
})(IntegrationExpireBehavior = exports.IntegrationExpireBehavior || (exports.IntegrationExpireBehavior = {}));
;
var InteractionCallbackType;
(function (InteractionCallbackType) {
    /** ACK a Ping */
    InteractionCallbackType[InteractionCallbackType["PONG"] = 1] = "PONG";
    /** respond to an interaction with a message */
    InteractionCallbackType[InteractionCallbackType["CHANNEL_MESSAGE_WITH_SOURCE"] = 4] = "CHANNEL_MESSAGE_WITH_SOURCE";
    /** ACK an interaction and edit a response later, the user sees a loading state */
    InteractionCallbackType[InteractionCallbackType["DEFERRED_CHANNEL_MESSAGE_WITH_SOURCE"] = 5] = "DEFERRED_CHANNEL_MESSAGE_WITH_SOURCE";
    /** for components, ACK an interaction and edit the original message later; the user does not see a loading state */
    InteractionCallbackType[InteractionCallbackType["DEFERRED_UPDATE_MESSAGE"] = 6] = "DEFERRED_UPDATE_MESSAGE";
    /** for components, edit the message the component was attached to */
    InteractionCallbackType[InteractionCallbackType["UPDATE_MESSAGE"] = 7] = "UPDATE_MESSAGE";
    /** respond to an autocomplete interaction with suggested choices */
    InteractionCallbackType[InteractionCallbackType["APPLICATION_COMMAND_AUTOCOMPLETE_RESULT"] = 8] = "APPLICATION_COMMAND_AUTOCOMPLETE_RESULT";
    /** respond to an interaction with a popup modal */
    InteractionCallbackType[InteractionCallbackType["MODAL"] = 9] = "MODAL";
})(InteractionCallbackType = exports.InteractionCallbackType || (exports.InteractionCallbackType = {}));
;
var InteractionType;
(function (InteractionType) {
    InteractionType[InteractionType["PING"] = 1] = "PING";
    InteractionType[InteractionType["APPLICATION_COMMAND"] = 2] = "APPLICATION_COMMAND";
    InteractionType[InteractionType["MESSAGE_COMPONENT"] = 3] = "MESSAGE_COMPONENT";
    InteractionType[InteractionType["APPLICATION_COMMAND_AUTOCOMPLETE"] = 4] = "APPLICATION_COMMAND_AUTOCOMPLETE";
    InteractionType[InteractionType["MODAL_SUBMIT"] = 5] = "MODAL_SUBMIT";
})(InteractionType = exports.InteractionType || (exports.InteractionType = {}));
;
var InviteTargetType;
(function (InviteTargetType) {
    InviteTargetType[InviteTargetType["STREAM"] = 1] = "STREAM";
    InviteTargetType[InviteTargetType["EMBEDDED_APPLICATION"] = 2] = "EMBEDDED_APPLICATION";
})(InviteTargetType = exports.InviteTargetType || (exports.InviteTargetType = {}));
;
var MembershipState;
(function (MembershipState) {
    MembershipState[MembershipState["INVITED"] = 1] = "INVITED";
    MembershipState[MembershipState["ACCEPTED"] = 2] = "ACCEPTED";
})(MembershipState = exports.MembershipState || (exports.MembershipState = {}));
;
var MessageActivityType;
(function (MessageActivityType) {
    MessageActivityType[MessageActivityType["JOIN"] = 1] = "JOIN";
    MessageActivityType[MessageActivityType["SPECTATE"] = 2] = "SPECTATE";
    MessageActivityType[MessageActivityType["LISTEN"] = 3] = "LISTEN";
    MessageActivityType[MessageActivityType["JOIN_REQUEST"] = 5] = "JOIN_REQUEST";
})(MessageActivityType = exports.MessageActivityType || (exports.MessageActivityType = {}));
;
exports.MessageFlag = {
    /** this message has been published to subscribed channels (via Channel Following) */
    CROSSPOSTED: 1 << 0,
    /** this message originated from a message in another channel (via Channel Following) */
    IS_CROSSPOST: 1 << 1,
    /** do not include any embeds when serializing this message */
    SUPPRESS_EMBEDS: 1 << 2,
    /** the source message for this crosspost has been deleted (via Channel Following) */
    SOURCE_MESSAGE_DELETED: 1 << 3,
    /** this message came from the urgent message system */
    URGENT: 1 << 4,
    /** this message has an associated thread, with the same id as the message */
    HAS_THREAD: 1 << 5,
    /** this message is only visible to the user who invoked the Interaction */
    EPHEMERAL: 1 << 6,
    /** this message is an Interaction Response and the bot is "thinking" */
    LOADING: 1 << 7,
    /** this message failed to mention some roles and add their members to the thread */
    FAILED_TO_MENTION_SOME_ROLES_IN_THREAD: 1 << 8,
};
var MessageType;
(function (MessageType) {
    MessageType[MessageType["DEFAULT"] = 0] = "DEFAULT";
    MessageType[MessageType["RECIPIENT_ADD"] = 1] = "RECIPIENT_ADD";
    MessageType[MessageType["RECIPIENT_REMOVE"] = 2] = "RECIPIENT_REMOVE";
    MessageType[MessageType["CALL"] = 3] = "CALL";
    MessageType[MessageType["CHANNEL_NAME_CHANGE"] = 4] = "CHANNEL_NAME_CHANGE";
    MessageType[MessageType["CHANNEL_ICON_CHANGE"] = 5] = "CHANNEL_ICON_CHANGE";
    MessageType[MessageType["CHANNEL_PINNED_MESSAGE"] = 6] = "CHANNEL_PINNED_MESSAGE";
    MessageType[MessageType["GUILD_MEMBER_JOIN"] = 7] = "GUILD_MEMBER_JOIN";
    MessageType[MessageType["USER_PREMIUM_GUILD_SUBSCRIPTION"] = 8] = "USER_PREMIUM_GUILD_SUBSCRIPTION";
    MessageType[MessageType["USER_PREMIUM_GUILD_SUBSCRIPTION_TIER_1"] = 9] = "USER_PREMIUM_GUILD_SUBSCRIPTION_TIER_1";
    MessageType[MessageType["USER_PREMIUM_GUILD_SUBSCRIPTION_TIER_2"] = 10] = "USER_PREMIUM_GUILD_SUBSCRIPTION_TIER_2";
    MessageType[MessageType["USER_PREMIUM_GUILD_SUBSCRIPTION_TIER_3"] = 11] = "USER_PREMIUM_GUILD_SUBSCRIPTION_TIER_3";
    MessageType[MessageType["CHANNEL_FOLLOW_ADD"] = 12] = "CHANNEL_FOLLOW_ADD";
    MessageType[MessageType["GUILD_DISCOVERY_DISQUALIFIED"] = 14] = "GUILD_DISCOVERY_DISQUALIFIED";
    MessageType[MessageType["GUILD_DISCOVERY_REQUALIFIED"] = 15] = "GUILD_DISCOVERY_REQUALIFIED";
    MessageType[MessageType["GUILD_DISCOVERY_GRACE_PERIOD_INITIAL_WARNING"] = 16] = "GUILD_DISCOVERY_GRACE_PERIOD_INITIAL_WARNING";
    MessageType[MessageType["GUILD_DISCOVERY_GRACE_PERIOD_FINAL_WARNING"] = 17] = "GUILD_DISCOVERY_GRACE_PERIOD_FINAL_WARNING";
    MessageType[MessageType["THREAD_CREATED"] = 18] = "THREAD_CREATED";
    MessageType[MessageType["REPLY"] = 19] = "REPLY";
    MessageType[MessageType["CHAT_INPUT_COMMAND"] = 20] = "CHAT_INPUT_COMMAND";
    MessageType[MessageType["THREAD_STARTER_MESSAGE"] = 21] = "THREAD_STARTER_MESSAGE";
    MessageType[MessageType["GUILD_INVITE_REMINDER"] = 22] = "GUILD_INVITE_REMINDER";
    MessageType[MessageType["CONTEXT_MENU_COMMAND"] = 23] = "CONTEXT_MENU_COMMAND";
})(MessageType = exports.MessageType || (exports.MessageType = {}));
;
var MfaLevel;
(function (MfaLevel) {
    /** guild has no MFA/2FA requirement for moderation actions */
    MfaLevel[MfaLevel["NONE"] = 0] = "NONE";
    /** guild has a 2FA requirement for moderation actions */
    MfaLevel[MfaLevel["ELEVATED"] = 1] = "ELEVATED";
})(MfaLevel = exports.MfaLevel || (exports.MfaLevel = {}));
;
exports.PermissionFlag = {
    /** Allows creation of instant invites */
    CREATE_INSTANT_INVITE: BigInt(1) << BigInt(0),
    /** Allows kicking members */
    KICK_MEMBERS: BigInt(1) << BigInt(1),
    /** Allows banning members */
    BAN_MEMBERS: BigInt(1) << BigInt(2),
    /** Allows all permissions and bypasses channel permission overwrites */
    ADMINISTRATOR: BigInt(1) << BigInt(3),
    /** Allows management and editing of channels */
    MANAGE_CHANNELS: BigInt(1) << BigInt(4),
    /** Allows management and editing of the guild */
    MANAGE_GUILD: BigInt(1) << BigInt(5),
    /** Allows for the addition of reactions to messages */
    ADD_REACTIONS: BigInt(1) << BigInt(6),
    /** Allows for viewing of audit logs */
    VIEW_AUDIT_LOG: BigInt(1) << BigInt(7),
    /** Allows for using priority speaker in a voice channel */
    PRIORITY_SPEAKER: BigInt(1) << BigInt(8),
    /** Allows the user to go live */
    STREAM: BigInt(1) << BigInt(9),
    /** Allows guild members to view a channel, which includes reading messages in text channels and joining voice channels */
    VIEW_CHANNEL: BigInt(1) << BigInt(10),
    /** Allows for sending messages in a channel and creating threads in a forum (does not allow sending messages in threads) */
    SEND_MESSAGES: BigInt(1) << BigInt(11),
    /** Allows for sending of /tts messages */
    SEND_TTS_MESSAGES: BigInt(1) << BigInt(12),
    /** Allows for deletion of other users messages */
    MANAGE_MESSAGES: BigInt(1) << BigInt(13),
    /** Links sent by users with this permission will be auto-embedded */
    EMBED_LINKS: BigInt(1) << BigInt(14),
    /** Allows for uploading images and files */
    ATTACH_FILES: BigInt(1) << BigInt(15),
    /** Allows for reading of message history */
    READ_MESSAGE_HISTORY: BigInt(1) << BigInt(16),
    /** Allows for using the @everyone tag to notify all users in a channel, and the @here tag to notify all online users in a channel */
    MENTION_EVERYONE: BigInt(1) << BigInt(17),
    /** Allows the usage of custom emojis from other servers */
    USE_EXTERNAL_EMOJIS: BigInt(1) << BigInt(18),
    /** Allows for viewing guild insights */
    VIEW_GUILD_INSIGHTS: BigInt(1) << BigInt(19),
    /** Allows for joining of a voice channel */
    CONNECT: BigInt(1) << BigInt(20),
    /** Allows for speaking in a voice channel */
    SPEAK: BigInt(1) << BigInt(21),
    /** Allows for muting members in a voice channel */
    MUTE_MEMBERS: BigInt(1) << BigInt(22),
    /** Allows for deafening of members in a voice channel */
    DEAFEN_MEMBERS: BigInt(1) << BigInt(23),
    /** Allows for moving of members between voice channels */
    MOVE_MEMBERS: BigInt(1) << BigInt(24),
    /** Allows for using voice-activity-detection in a voice channel */
    USE_VAD: BigInt(1) << BigInt(25),
    /** Allows for modification of own nickname */
    CHANGE_NICKNAME: BigInt(1) << BigInt(26),
    /** Allows for modification of other users nicknames */
    MANAGE_NICKNAMES: BigInt(1) << BigInt(27),
    /** Allows management and editing of roles */
    MANAGE_ROLES: BigInt(1) << BigInt(28),
    /** Allows management and editing of webhooks */
    MANAGE_WEBHOOKS: BigInt(1) << BigInt(29),
    /** Allows management and editing of emojis and stickers */
    MANAGE_EMOJIS_AND_STICKERS: BigInt(1) << BigInt(30),
    /** Allows members to use application commands, including slash commands and context menu commands. */
    USE_APPLICATION_COMMANDS: BigInt(1) << BigInt(31),
    /** Allows for requesting to speak in stage channels. (This permission is under active development and may be changed or removed.) */
    REQUEST_TO_SPEAK: BigInt(1) << BigInt(32),
    /** Allows for creating, editing, and deleting scheduled events */
    MANAGE_EVENTS: BigInt(1) << BigInt(33),
    /** Allows for deleting and archiving threads, and viewing all private threads */
    MANAGE_THREADS: BigInt(1) << BigInt(34),
    /** Allows for creating public and announcement threads */
    CREATE_PUBLIC_THREADS: BigInt(1) << BigInt(35),
    /** Allows for creating private threads */
    CREATE_PRIVATE_THREADS: BigInt(1) << BigInt(36),
    /** Allows the usage of custom stickers from other servers */
    USE_EXTERNAL_STICKERS: BigInt(1) << BigInt(37),
    /** Allows for sending messages in threads */
    SEND_MESSAGES_IN_THREADS: BigInt(1) << BigInt(38),
    /** Allows for using Activities (applications with the EMBEDDED flag) in a voice channel */
    USE_EMBEDDED_ACTIVITIES: BigInt(1) << BigInt(39),
    /** Allows for timing out users to prevent them from sending or reacting to messages in chat and threads, and from speaking in voice and stage channels */
    MODERATE_MEMBERS: BigInt(1) << BigInt(40),
};
var PremiumTier;
(function (PremiumTier) {
    /** guild has not unlocked any Server Boost perks */
    PremiumTier[PremiumTier["NONE"] = 0] = "NONE";
    /** guild has unlocked Server Boost level 1 perks */
    PremiumTier[PremiumTier["TIER_1"] = 1] = "TIER_1";
    /** guild has unlocked Server Boost level 2 perks */
    PremiumTier[PremiumTier["TIER_2"] = 2] = "TIER_2";
    /** guild has unlocked Server Boost level 3 perks */
    PremiumTier[PremiumTier["TIER_3"] = 3] = "TIER_3";
})(PremiumTier = exports.PremiumTier || (exports.PremiumTier = {}));
;
var PremiumType;
(function (PremiumType) {
    PremiumType[PremiumType["NONE"] = 0] = "NONE";
    PremiumType[PremiumType["NITRO_CLASSIC"] = 1] = "NITRO_CLASSIC";
    PremiumType[PremiumType["NITRO"] = 2] = "NITRO";
})(PremiumType = exports.PremiumType || (exports.PremiumType = {}));
;
var PrivacyLevel;
(function (PrivacyLevel) {
    /** The Stage instance is visible publicly. (deprecated) */
    PrivacyLevel[PrivacyLevel["PUBLIC"] = 1] = "PUBLIC";
    /** The Stage instance is visible to only guild members. */
    PrivacyLevel[PrivacyLevel["GUILD_ONLY"] = 2] = "GUILD_ONLY";
})(PrivacyLevel = exports.PrivacyLevel || (exports.PrivacyLevel = {}));
;
var StatusType;
(function (StatusType) {
    /** Online */
    StatusType["ONLINE"] = "online";
    /** Do Not Disturb */
    StatusType["DND"] = "dnd";
    /** AFK */
    StatusType["IDLE"] = "idle";
    /** Invisible and shown as offline */
    StatusType["INVISIBLE"] = "invisible";
    /** Offline */
    StatusType["OFFLINE"] = "offline";
})(StatusType = exports.StatusType || (exports.StatusType = {}));
;
var StickerFormatType;
(function (StickerFormatType) {
    StickerFormatType[StickerFormatType["PNG"] = 1] = "PNG";
    StickerFormatType[StickerFormatType["APNG"] = 2] = "APNG";
    StickerFormatType[StickerFormatType["LOTTIE"] = 3] = "LOTTIE";
})(StickerFormatType = exports.StickerFormatType || (exports.StickerFormatType = {}));
;
var StickerType;
(function (StickerType) {
    /** an official sticker in a pack, part of Nitro or in a removed purchasable pack */
    StickerType[StickerType["STANDARD"] = 1] = "STANDARD";
    /** a sticker uploaded to a Boosted guild for the guild's members */
    StickerType[StickerType["GUILD"] = 2] = "GUILD";
})(StickerType = exports.StickerType || (exports.StickerType = {}));
;
exports.SystemChannelFlag = {
    /** Suppress member join notifications */
    SUPPRESS_JOIN_NOTIFICATIONS: 1 << 0,
    /** Suppress server boost notifications */
    SUPPRESS_PREMIUM_SUBSCRIPTIONS: 1 << 1,
    /** Suppress server setup tips */
    SUPPRESS_GUILD_REMINDER_NOTIFICATIONS: 1 << 2,
    /** Hide member join sticker reply buttons */
    SUPPRESS_JOIN_NOTIFICATION_REPLIES: 1 << 3,
};
var TextInputStyle;
(function (TextInputStyle) {
    /** A single-line input */
    TextInputStyle[TextInputStyle["SHORT"] = 1] = "SHORT";
    /** A multi-line input */
    TextInputStyle[TextInputStyle["PARAGRAPH"] = 2] = "PARAGRAPH";
})(TextInputStyle = exports.TextInputStyle || (exports.TextInputStyle = {}));
;
exports.UserFlag = {
    /** Discord Employee */
    STAFF: 1 << 0,
    /** Partnered Server Owner */
    PARTNER: 1 << 1,
    /** HypeSquad Events Member */
    HYPESQUAD: 1 << 2,
    /** Bug Hunter Level 1 */
    BUG_HUNTER_LEVEL_1: 1 << 3,
    /** House Bravery Member */
    HYPESQUAD_ONLINE_HOUSE_1: 1 << 6,
    /** House Brilliance Member */
    HYPESQUAD_ONLINE_HOUSE_2: 1 << 7,
    /** House Balance Member */
    HYPESQUAD_ONLINE_HOUSE_3: 1 << 8,
    /** Early Nitro Supporter */
    PREMIUM_EARLY_SUPPORTER: 1 << 9,
    /** User is a team */
    TEAM_PSEUDO_USER: 1 << 10,
    /** Bug Hunter Level 2 */
    BUG_HUNTER_LEVEL_2: 1 << 14,
    /** Verified Bot */
    VERIFIED_BOT: 1 << 16,
    /** Early Verified Bot Developer */
    VERIFIED_DEVELOPER: 1 << 17,
    /** Discord Certified Moderator */
    CERTIFIED_MODERATOR: 1 << 18,
    /** Bot uses only HTTP interactions and is shown in the online member list */
    BOT_HTTP_INTERACTIONS: 1 << 19,
};
var VerificationLevel;
(function (VerificationLevel) {
    /** unrestricted */
    VerificationLevel[VerificationLevel["NONE"] = 0] = "NONE";
    /** must have verified email on account */
    VerificationLevel[VerificationLevel["LOW"] = 1] = "LOW";
    /** must be registered on Discord for longer than 5 minutes */
    VerificationLevel[VerificationLevel["MEDIUM"] = 2] = "MEDIUM";
    /** must be a member of the server for longer than 10 minutes */
    VerificationLevel[VerificationLevel["HIGH"] = 3] = "HIGH";
    /** must have a verified phone number */
    VerificationLevel[VerificationLevel["VERY_HIGH"] = 4] = "VERY_HIGH";
})(VerificationLevel = exports.VerificationLevel || (exports.VerificationLevel = {}));
;
var VideoQualityMode;
(function (VideoQualityMode) {
    /** Discord chooses the quality for optimal performance */
    VideoQualityMode[VideoQualityMode["AUTO"] = 1] = "AUTO";
    /** 720p */
    VideoQualityMode[VideoQualityMode["FULL"] = 2] = "FULL";
})(VideoQualityMode = exports.VideoQualityMode || (exports.VideoQualityMode = {}));
;
var VisibilityType;
(function (VisibilityType) {
    /** invisible to everyone except the user themselves */
    VisibilityType[VisibilityType["NONE"] = 0] = "NONE";
    /** visible to everyone */
    VisibilityType[VisibilityType["EVERYONE"] = 1] = "EVERYONE";
})(VisibilityType = exports.VisibilityType || (exports.VisibilityType = {}));
;
var VoiceOpcode;
(function (VoiceOpcode) {
    /** Begin a voice websocket connection. */
    VoiceOpcode[VoiceOpcode["IDENTIFY"] = 0] = "IDENTIFY";
    /** Select the voice protocol. */
    VoiceOpcode[VoiceOpcode["SELECT_PROTOCOL"] = 1] = "SELECT_PROTOCOL";
    /** Complete the websocket handshake. */
    VoiceOpcode[VoiceOpcode["READY"] = 2] = "READY";
    /** Keep the websocket connection alive. */
    VoiceOpcode[VoiceOpcode["HEARTBEAT"] = 3] = "HEARTBEAT";
    /** Describe the session. */
    VoiceOpcode[VoiceOpcode["SESSION_DESCRIPTION"] = 4] = "SESSION_DESCRIPTION";
    /** Indicate which users are speaking. */
    VoiceOpcode[VoiceOpcode["SPEAKING"] = 5] = "SPEAKING";
    /** Sent to acknowledge a received client heartbeat. */
    VoiceOpcode[VoiceOpcode["HEARTBEAT_ACK"] = 6] = "HEARTBEAT_ACK";
    /** Resume a connection. */
    VoiceOpcode[VoiceOpcode["RESUME"] = 7] = "RESUME";
    /** Time to wait between sending heartbeats in milliseconds. */
    VoiceOpcode[VoiceOpcode["HELLO"] = 8] = "HELLO";
    /** Acknowledge a successful session resume. */
    VoiceOpcode[VoiceOpcode["RESUMED"] = 9] = "RESUMED";
    /** A client has disconnected from the voice channel */
    VoiceOpcode[VoiceOpcode["CLIENT_DISCONNECT"] = 13] = "CLIENT_DISCONNECT";
})(VoiceOpcode = exports.VoiceOpcode || (exports.VoiceOpcode = {}));
;
var WebhookType;
(function (WebhookType) {
    /** Incoming Webhooks can post messages to channels with a generated token */
    WebhookType[WebhookType["INCOMING"] = 1] = "INCOMING";
    /** Channel Follower Webhooks are internal webhooks used with Channel Following to post new messages into channels */
    WebhookType[WebhookType["CHANNEL_FOLLOWER"] = 2] = "CHANNEL_FOLLOWER";
    /** Application webhooks are webhooks used with Interactions */
    WebhookType[WebhookType["APPLICATION"] = 3] = "APPLICATION";
})(WebhookType = exports.WebhookType || (exports.WebhookType = {}));
;
